#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void lumped_inertia_mat(struct geo_data *geo)
{
	int i = 0;	
	int ti,tj,tk,tl;

//eOp`̊sMp̌vZ(lumped inertia matrix)-------------------
	for(i=0;i<tri_Num;i++)
	{
		ti = geo->triangle[i].point_i;
		tj = geo->triangle[i].point_j;
		tk = geo->triangle[i].point_k;
		tl = geo->triangle[i].point_l;

		geo->MX[ti]	+= (D*geo->triangle[i].area)/4.0;
		geo->MY[ti]	+= (D*geo->triangle[i].area)/4.0;
		geo->MZ[ti]	+= (D*geo->triangle[i].area)/4.0;

		geo->MX[tj]	+= (D*geo->triangle[i].area)/4.0;
		geo->MY[tj]	+= (D*geo->triangle[i].area)/4.0;
		geo->MZ[tj]	+= (D*geo->triangle[i].area)/4.0;

		geo->MX[tk]	+= (D*geo->triangle[i].area)/4.0;
		geo->MY[tk]	+= (D*geo->triangle[i].area)/4.0;
		geo->MZ[tk]	+= (D*geo->triangle[i].area)/4.0;

		geo->MX[tl]	+= (D*geo->triangle[i].area)/4.0;
		geo->MY[tl]	+= (D*geo->triangle[i].area)/4.0;
		geo->MZ[tl]	+= (D*geo->triangle[i].area)/4.0;
	}
	//--------------------------------------------------------------------
}