#define	MaxVars		40960	//20480//10240//256

extern void RungeKuttaOneStep(int, double *, void (int, double *, double, double *, struct geo_data geo), double *, double, struct geo_data geo);
extern void RungeKuttafprint(FILE *, int, double *, double);
extern void RungeKutta(FILE *, int, double *, void (int, double *, double, double *, struct geo_data geo), double *, double, long, struct geo_data geo);

extern void RungeKuttaFehlbergOneStep(int n, double x[], void diff(int, double *, double, double *), double *pt, double dt);
extern void RungeKuttaFehlbergfprint(FILE *fd, int n, double x[], double t);
extern void RungeKuttaFehlberg(FILE *fd, int n, double x[], void diff(int, double *, double, double *), double *pt, double dt, long kcnt);

extern void RungeKuttaFehlbergAdaptiveOneStep(int n, double x[], void diff(int, double *, double, double *, struct geo_data geo), double *pt, double *pdt, struct geo_data geo);
extern void RungeKuttaFehlbergAdaptivefprint(FILE *fd, int n, double x[], double t, double dt, int *cnt);
extern void RungeKuttaFehlbergAdaptive(FILE *fd, int n, double x[], void diff(int, double *, double, double *, struct geo_data geo), double *pt, double *pdt, double tend, long kcnt, struct geo_data geo, int *cn);