#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

double triangleArea(int i,struct geo_data *geo);

//lʑ̗vf̐ϋϊ֐
double triangleArea(int i,struct geo_data *geo)
{
	double xi,xj,xk,xl,yi,yj,yk,yl,zi,zj,zk,zl;
	double s;
	double v[4];

	xi	= geo->point[geo->triangle[i].point_i].x;
	xj	= geo->point[geo->triangle[i].point_j].x;
	xk	= geo->point[geo->triangle[i].point_k].x;
	xl	= geo->point[geo->triangle[i].point_l].x;

	yi	= geo->point[geo->triangle[i].point_i].y;
	yj	= geo->point[geo->triangle[i].point_j].y;
	yk	= geo->point[geo->triangle[i].point_k].y;
	yl	= geo->point[geo->triangle[i].point_l].y;

	zi	= geo->point[geo->triangle[i].point_i].z;
	zj	= geo->point[geo->triangle[i].point_j].z;
	zk	= geo->point[geo->triangle[i].point_k].z;
	zl	= geo->point[geo->triangle[i].point_l].z;

	v[0]	=	((xl*yk*zj+xk*yj*zl+xj*yl*zk)-(xj*yk*zl+xk*yl*zj+xl*yj*zk))/6;	//OPjPkPl
	v[1]	=	((xi*yl*zk+xl*yk*zi+xk*yi*zl)-(xk*yl*zi+xl*yi*zk+xi*yk*zl))/6;	//OPkPlPi
	v[2]	=	((xj*yi*zl+xi*yl*zj+xl*yj*zi)-(xl*yi*zj+xi*yj*zl+xj*yl*zi))/6;	//OPlPiPj
	v[3]	=	((xk*yj*zi+xj*yi*zk+xi*yk*zj)-(xi*yj*zk+xj*yk*zi+xk*yi*zj))/6;	//OPiPjPk
	
	s	= v[0]-v[1]+v[2]-v[3];//̐ρPiPjPkPl

	return s;
}

void make_MatandArea(FILE *fg, struct geo_data *geo)
{
	temp temp[tri_Num];
	int i,j,k,l;	//i:tri_Num j:
	int p[4]={1,-1,1,-1};//t
	//lʑ̗vf̑̐ς߂
	for(i=0;i<tri_Num;i++){
		geo->triangle[i].area = triangleArea(i,geo);

#if	0		//mFp
		
		fprintf(fg,"%d\t%.15lf\n",i,geo->triangle[i].area);

#endif		//mFp

	}

	
	//ڑs񐶐
	double mata[tri_Num][4];
	double matb[tri_Num][4];
	double matc[tri_Num][4];
	double matyz[4][3];
	double matzx[4][3];
	double matxy[4][3];
	int t[4];
	int ta,tb,tc;

	for(i=0;i<tri_Num;i++){
		
		t[0] = geo->triangle[i].point_j;
		t[1] = geo->triangle[i].point_k;
		t[2] = geo->triangle[i].point_l;
		t[3] = geo->triangle[i].point_i;

#if	0	//mFp
		fprintf(fg,"%d\t%d\t%d\t%d\n\n",t[0],t[1],t[2],t[3]);
#endif
//--------------------------------a,b,c-----------------------------------------//
//x: y: z:
//j=0:jkl  j=1:kli  j=2:lij  j=3:ijk  ta,tb,tc
		for(j=0;j<4;j++){
			k=j;

			ta=t[k];

			if(k+1>3)	k=k-4;

			tb=t[k+1];

			if(k+2>3)	k=k-4;

			tc=t[k+2];
			//a	(yz)
			matyz[j][0] = geo->point[ta].y * geo->point[tb].z - geo->point[tb].y * geo->point[ta].z;
			matyz[j][1] = geo->point[tb].y * geo->point[tc].z - geo->point[tc].y * geo->point[tb].z;
			matyz[j][2] = geo->point[tc].y * geo->point[ta].z - geo->point[ta].y * geo->point[tc].z;
			mata[i][j] = matyz[j][0] + matyz[j][1] + matyz[j][2];	//a
			
			//b	(zx)
			matzx[j][0] = geo->point[ta].z * geo->point[tb].x - geo->point[tb].z * geo->point[ta].x;
			matzx[j][1] = geo->point[tb].z * geo->point[tc].x - geo->point[tc].z * geo->point[tb].x;
			matzx[j][2] = geo->point[tc].z * geo->point[ta].x - geo->point[ta].z * geo->point[tc].x;
			matb[i][j] = matzx[j][0] + matzx[j][1] + matzx[j][2];	//b

			//c	(xy)
			matxy[j][0] = geo->point[ta].x * geo->point[tb].y - geo->point[tb].x * geo->point[ta].y;
			matxy[j][1] = geo->point[tb].x * geo->point[tc].y - geo->point[tc].x * geo->point[tb].y;
			matxy[j][2] = geo->point[tc].x * geo->point[ta].y - geo->point[ta].x * geo->point[tc].y;
			matc[i][j] = matxy[j][0] + matxy[j][1] + matxy[j][2];	//c

		}
	}

//----------------------aa,ab,ac,ba,bb,bc,ca,cb,cc---------------------------//
//jkl:0, kli:1, lij:2, ijk:3; jkl:0, kli:1, lij:2, ijk:3 -> jkl; jkl:l=0

	for(i=0;i<tri_Num;i++)
	{
		for(k=0,l=0;k<4;k++)
		{
			for(j=0;j<4;j++)
			{			

				temp[i].matrix[l].mat[0][0] =	(mata[i][k])*(mata[i][j]);		//aa
				temp[i].matrix[l].mat[0][1] =	(mata[i][k])*(matb[i][j]);		//ab
				temp[i].matrix[l].mat[0][2] =	(mata[i][k])*(matc[i][j]);		//ac
	
				temp[i].matrix[l].mat[1][0] =	(matb[i][k])*(mata[i][j]);		//ba
				temp[i].matrix[l].mat[1][1] =	(matb[i][k])*(matb[i][j]);		//bb
				temp[i].matrix[l].mat[1][2] =	(matb[i][k])*(matc[i][j]);		//bc

				temp[i].matrix[l].mat[2][0] =	(matc[i][k])*(mata[i][j]);		//ca
				temp[i].matrix[l].mat[2][1] =	(matc[i][k])*(matb[i][j]);		//cb
				temp[i].matrix[l].mat[2][2] =	(matc[i][k])*(matc[i][j]);		//cc

				l++;

			}
		}
	}

//----------------------------J12~12--------------------------//
	for(i=0;i<tri_Num;i++)
	{
		for(j=0,l=0;j<4;j++)
		{
			for(k=0;k<4;k++)
			{

				geo->triangle[i].mat_lambda[j*3+0][k*3+0]	=	p[j] * p[k] * temp[i].matrix[l].mat[0][0];	//aa
				geo->triangle[i].mat_lambda[j*3+0][k*3+1]	=	p[j] * p[k] * temp[i].matrix[l].mat[0][1];	//ab
				geo->triangle[i].mat_lambda[j*3+0][k*3+2]	=	p[j] * p[k] * temp[i].matrix[l].mat[0][2];	//ac

				geo->triangle[i].mat_lambda[j*3+1][k*3+0]	=	p[j] * p[k] * temp[i].matrix[l].mat[1][0];	//ba
				geo->triangle[i].mat_lambda[j*3+1][k*3+1]	=	p[j] * p[k] * temp[i].matrix[l].mat[1][1];	//bb
				geo->triangle[i].mat_lambda[j*3+1][k*3+2]	=	p[j] * p[k] * temp[i].matrix[l].mat[1][2];	//bc
	
				geo->triangle[i].mat_lambda[j*3+2][k*3+0]	=	p[j] * p[k] * temp[i].matrix[l].mat[2][0];	//ca
				geo->triangle[i].mat_lambda[j*3+2][k*3+1]	=	p[j] * p[k] * temp[i].matrix[l].mat[2][1];	//cb
				geo->triangle[i].mat_lambda[j*3+2][k*3+2]	=	p[j] * p[k] * temp[i].matrix[l].mat[2][2];	//cc
				
				l++;
			}
		}
	}
//---------------------------------J12~12---------------------------------------------------//
	for(i=0;i<tri_Num;i++){
		for(j=0,l=0;j<4;j++){
			for(k=0;k<4;k++){

				geo->triangle[i].mat_mu[j*3+0][k*3+0]	=	p[j]*p[k]*(2*temp[i].matrix[l].mat[0][0] +temp[i].matrix[l].mat[1][1] +temp[i].matrix[l].mat[2][2]);	//2*aa+bb+cc
				geo->triangle[i].mat_mu[j*3+0][k*3+1]	=	p[j]*p[k]*(								 +temp[i].matrix[l].mat[1][0]);	//ba
				geo->triangle[i].mat_mu[j*3+0][k*3+2]	=	p[j]*p[k]*(								 +temp[i].matrix[l].mat[2][0]);	//ca

				geo->triangle[i].mat_mu[j*3+1][k*3+0]	=	p[j]*p[k]*(								 +temp[i].matrix[l].mat[0][1]);	//ab
				geo->triangle[i].mat_mu[j*3+1][k*3+1]	=	p[j]*p[k]*(2*temp[i].matrix[l].mat[1][1] +temp[i].matrix[l].mat[2][2] +temp[i].matrix[l].mat[0][0]);	//2*bb+cc+aa
				geo->triangle[i].mat_mu[j*3+1][k*3+2]	=	p[j]*p[k]*(								 +temp[i].matrix[l].mat[2][1]);	//cb
	
				geo->triangle[i].mat_mu[j*3+2][k*3+0]	=	p[j]*p[k]*(								 +temp[i].matrix[l].mat[0][2]);	//ac
				geo->triangle[i].mat_mu[j*3+2][k*3+1]	=	p[j]*p[k]*(								 +temp[i].matrix[l].mat[1][2]);	//bc
				geo->triangle[i].mat_mu[j*3+2][k*3+2]	=	p[j]*p[k]*(2*temp[i].matrix[l].mat[2][2] +temp[i].matrix[l].mat[0][0] +temp[i].matrix[l].mat[1][1]);	//2*cc+aa+bb
				
				l++;
			
			}
		}
	}
//---------------------------JɁ@J----------------------------------------------//

	for(i=0;i<tri_Num;i++){
		for(j=0;j<12;j++){
			for(k=0;k<12;k++){
				geo->triangle[i].mat_lambda[j][k]	= (1/(36*geo->triangle[i].area))*geo->triangle[i].mat_lambda[j][k];	//Jlamp
				geo->triangle[i].mat_mu[j][k]		= (1/(36*geo->triangle[i].area))*geo->triangle[i].mat_mu[j][k];		//Jmup
			}
		}
	}

//-----------------eOp`vf̃[̒萔-------------------//

	for(i=0;i<tri_Num;i++){
		geo->triangle[i].Lela	= Lela;
		geo->triangle[i].Mela	= Mela;
		geo->triangle[i].Lvis	= Lvis;
		geo->triangle[i].Mvis	= Mvis;
		geo->triangle[i].Ltvis	= Ltvis;
		geo->triangle[i].Mtvis	= Mtvis;

	}
//------------------------------------------------------------------//
}

