#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"
#include "structdata.h"

void compValue(double FX[],double FY[],double FZ[],double nsx[],double nsy[],double nsz[],double npx[],double npy[],double npz[],
				double x[],double value[],double LMX[],double LMY[],double LMZ[],double t,struct geo_data geo)
{
	int i = 0;
	double	CSMX[node_Num];				//ʍSpCSMϐ
	double	CSMY[node_Num];
	double	CSMZ[node_Num];

	int j,k;
//-----------------CSM  ʈȊO̍S͌vZ܂
	for(i=0;i<wide+1;i++)	//wide
	{
		for(j=0;j<depth+1;j++)	//depth
		{
			for(k=0;k<height+1;k++)	//height
			{
			CSMX[i+j*(wide+1)+k*(wide+1)*(depth+1)] = 2*omega*nsx[i+j*(wide+1)+k*(wide+1)*(depth+1)]+(omega*omega)*npx[i+j*(wide+1)+k*(wide+1)*(depth+1)];	//2**Vn+^2*Un
			CSMY[i+j*(wide+1)+k*(wide+1)*(depth+1)] = 2*omega*nsy[i+j*(wide+1)+k*(wide+1)*(depth+1)]+(omega*omega)*npy[i+j*(wide+1)+k*(wide+1)*(depth+1)];
			CSMZ[i+j*(wide+1)+k*(wide+1)*(depth+1)] = 2*omega*nsz[i+j*(wide+1)+k*(wide+1)*(depth+1)]+(omega*omega)*npz[i+j*(wide+1)+k*(wide+1)*(depth+1)];

			LMX[i+j*(wide+1)+k*(wide+1)*(depth+1)] = FX[i+j*(wide+1)+k*(wide+1)*(depth+1)]-(1.0/geo.MX[i+j*(wide+1)+k*(wide+1)*(depth+1)])*CSMX[i+j*(wide+1)+k*(wide+1)*(depth+1)];
			LMY[i+j*(wide+1)+k*(wide+1)*(depth+1)] = FY[i+j*(wide+1)+k*(wide+1)*(depth+1)]-(1.0/geo.MY[i+j*(wide+1)+k*(wide+1)*(depth+1)])*CSMY[i+j*(wide+1)+k*(wide+1)*(depth+1)];
			LMZ[i+j*(wide+1)+k*(wide+1)*(depth+1)] = FZ[i+j*(wide+1)+k*(wide+1)*(depth+1)]-(1.0/geo.MZ[i+j*(wide+1)+k*(wide+1)*(depth+1)])*CSMZ[i+j*(wide+1)+k*(wide+1)*(depth+1)];
	
			value[(3*(i+j*(wide+1)+k*(wide+1)*(depth+1))+0)+(12*node_Num)]		= LMX[i+j*(wide+1)+k*(wide+1)*(depth+1)];
			value[(3*(i+j*(wide+1)+k*(wide+1)*(depth+1))+1)+(12*node_Num)]		= LMY[i+j*(wide+1)+k*(wide+1)*(depth+1)];
			value[(3*(i+j*(wide+1)+k*(wide+1)*(depth+1))+2)+(12*node_Num)]		= LMZ[i+j*(wide+1)+k*(wide+1)*(depth+1)];
			}
		}
	}

//------d/dt(u)=	m[h̑x----------
	for(i=0;i<node_Num*3;i++)
	{
		value[i] = x[i+(3*node_Num)];
	}
//----------------------------------------

//------d/dt(v)=	m[h̉x----------------
	for(i=0;i<node_Num;i++)
	{

		value[3*node_Num+(i*3+0)]	= (1.0/geo.MX[i])*(-FX[i]);
		value[3*node_Num+(i*3+1)]	= (1.0/geo.MY[i])*(-FY[i]);
		value[3*node_Num+(i*3+2)]	= (1.0/geo.MZ[i])*(-FZ[i]);

	}

//-----ʈȊOSɌŒ肳Ăꍇ܂-----//
	for(i=csm_x_node[0];i<csm_x_node[1]+1;i++)	//wide
	{
		for(j=csm_z_node[0];j<csm_z_node[1]+1;j++)	//depth
		{
			for(k=csm_y_node[0];k<csm_y_node[1]+1;k++)	//height
			{
				if(BINDING_X)
					value[((i+j*(wide+1)+k*(wide+1)*(depth+1))*3+0)+3*node_Num]	= -CSMX[i+j*(wide+1)+k*(wide+1)*(depth+1)];			//XS
				if(BINDING_Y)
					value[((i+j*(wide+1)+k*(wide+1)*(depth+1))*3+1)+3*node_Num]	= -CSMY[i+j*(wide+1)+k*(wide+1)*(depth+1)];			//YS
				if(BINDING_Z)
					value[((i+j*(wide+1)+k*(wide+1)*(depth+1))*3+2)+3*node_Num]	= -CSMZ[i+j*(wide+1)+k*(wide+1)*(depth+1)];			//ZS
			}
		}
	}


//-----ʂɖCꍇ()--------------------------------------
	if(FRICTION){

		for(i=0;i<(wide+1)*(depth+1);i++)
		{
			if(fabs(FX[i])<fric_max_mu*(MASS/(wide+1)*(depth+1)+FY[i]))	//őÎ~C
				value[(i*3+0)+3*node_Num]		= -CSMX[i];
			else
			{
				if(FX[i]<0)	
					FX[i]=FX[i]+fric_mu*(MASS/(wide+1)*(depth+1)+FY[i]);
				else if(FX[i]>0)
					FX[i]=FX[i]-fric_mu*(MASS/(wide+1)*(depth+1)+FY[i]);
			
				value[(i*3	)+3*node_Num]		= (1.0/geo.MX[i])*(-FX[i]);	

			}
			if(fabs(FZ[i])<fric_max_mu*(MASS/(wide+1)*(depth+1)+FY[i]))	//őÎ~C
				value[(i*3+2)+3*node_Num]		= -CSMZ[i];
			else
			{
				if(FZ[i]<0)	
					FZ[i]=FZ[i]+fric_mu*(MASS/(wide+1)*(depth+1)+FY[i]);
				else if(FZ[i]>0)
					FZ[i]=FZ[i]-fric_mu*(MASS/(wide+1)*(depth+1)+FY[i]);
			
				value[(i*3+2)+3*node_Num]		= (1.0/geo.MZ[i])*(-FZ[i]);	

			}
			
			value[(i*3+1)+3*node_Num]	= -CSMY[i];	
		}
	}
//------------------------------------------------------------------------

}	
