#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>
#include "RK.h"
#include "data.h"
#include "func.h"

//CSMvZ֐
void add_csmmove(double npx[],double npy[],double npz[],double nsx[],double nsy[],double nsz[],double value[],double t)
{
	int i,j,k = 0;
	int push_node[6]={0};
	double MCSMX[node_Num];				//ψʗpCSMϐ
	double MCSMY[node_Num];
	double MCSMZ[node_Num];

	
	if(push_case==1)		//S̉
	{
		push_node[0] = 0;
		push_node[1] = depth;
		push_node[2] = 0;
		push_node[3] = wide;
		push_node[4] = height;
		push_node[5] = height;
	}
	else if(push_case==2)
	{
		push_node[0] = (depth/2)-1;
		push_node[1] = (depth/2)+1;
		push_node[2] = (wide/2)-1;
		push_node[3] = (wide/2)+1;
		push_node[4] = height;
		push_node[5] = height;
	}

	else if(push_case==3)
	{
		push_node[0] = (depth/2)-(ex_depth/2);
		push_node[1] = (depth/2)+(ex_depth/2);
		push_node[2] = (wide/2)-(ex_wide/2);
		push_node[3] = (wide/2)+(ex_wide/2);
		push_node[4] = height;
		push_node[5] = height;
	}
	else if(push_case==4)
	{
		push_node[0] = 0;		//depth1(s)
		push_node[1] = depth;		//depth2(s)
		push_node[2] = wide;		//wide1 ()
		push_node[3] = wide;		//wide2 ()
		push_node[4] = 0;
		push_node[5] = height;
	}

//-----------------CSM(ψ)̌vZ------------------
	if(t<=mbf_time)//ʋψʗp(Ԃό`܂Łj
	{				//t=0`mbf_time܂ŋψʏԁiψʁj
		for(j=push_node[4];j<push_node[5]+1;j++)								//̏ʁ@y
		{
			for(k=push_node[0];k<push_node[1]+1;k++)							//̏ʁ@z
			{
				for(i=push_node[2];i<push_node[3]+1;i++)						//̏ʁ@x
				{
				MCSMX[(wide+1)*(depth+1)*j+(wide+1)*k+i] = 2*omega*(nsx[(wide+1)*(depth+1)*j+(wide+1)*k+i]
					+(move_x/mbf_time))+(omega*omega)*(npx[(wide+1)*(depth+1)*j+(wide+1)*k+i]+(move_x/mbf_time)*t);		//xɕψʂ

				MCSMY[(wide+1)*(depth+1)*j+(wide+1)*k+i] = 2*omega*(nsy[(wide+1)*(depth+1)*j+(wide+1)*k+i]
					+(move_y/mbf_time))+(omega*omega)*(npy[(wide+1)*(depth+1)*j+(wide+1)*k+i]+(move_y/mbf_time)*t);		//yɕψʂ

				MCSMZ[(wide+1)*(depth+1)*j+(wide+1)*k+i] = 2*omega*(nsz[(wide+1)*(depth+1)*j+(wide+1)*k+i]
					+(move_z/mbf_time))+(omega*omega)*(npz[(wide+1)*(depth+1)*j+(wide+1)*k+i]+(move_z/mbf_time)*t);		//zɕψʂ

				value[3*node_Num+3*(wide+1)*(depth+1)*j+3*(wide+1)*k+3*i+1]	= -MCSMY[(wide+1)*(depth+1)*j+(wide+1)*k+i];	//y̍S
				if(BINDING){		//S(ʊ̗L)
					value[3*node_Num+3*(wide+1)*(depth+1)*j+3*(wide+1)*k+3*i  ]	= -MCSMX[(wide+1)*(depth+1)*j+(wide+1)*k+i];	//x̍S
					value[3*node_Num+3*(wide+1)*(depth+1)*j+3*(wide+1)*k+3*i+2]	= -MCSMZ[(wide+1)*(depth+1)*j+(wide+1)*k+i];	//z̍S
				}


				}
			}
		}
	}
	else if(t>mbf_time && t<=mbf_time+keep_time)//ʋψʏԕێp
	{			//t=mbf_time`keep_time܂ŋψʕێ
		for(j=push_node[4];j<push_node[5]+1;j++)								//̏ʁ@y
		{
			for(k=push_node[0];k<push_node[1]+1;k++)							//̏ʁ@z
			{
				for(i=push_node[2];i<push_node[3]+1;i++)						//̏ʁ@x
				{
					MCSMX[(wide+1)*(depth+1)*j+(wide+1)*k+i] = 2*omega*nsx[(wide+1)*(depth+1)*j+(wide+1)*k+i]
					+(omega*omega)*(npx[(wide+1)*(depth+1)*j+(wide+1)*k+i]+move_x);										//xɕψʌŒ

					MCSMY[(wide+1)*(depth+1)*j+(wide+1)*k+i] = 2*omega*nsy[(wide+1)*(depth+1)*j+(wide+1)*k+i]
					+(omega*omega)*(npy[(wide+1)*(depth+1)*j+(wide+1)*k+i]+move_y);										//yɕψʌŒ

					MCSMZ[(wide+1)*(depth+1)*j+(wide+1)*k+i] = 2*omega*nsz[(wide+1)*(depth+1)*j+(wide+1)*k+i]
					+(omega*omega)*(npz[(wide+1)*(depth+1)*j+(wide+1)*k+i]+move_z);										//zɕψʌŒ
			

					value[3*node_Num+3*(wide+1)*(depth+1)*j+3*(wide+1)*k+3*i+1]	= -MCSMY[(wide+1)*(depth+1)*j+(wide+1)*k+i];	//y̍S
					if(BINDING){		//S(ʊ̗L)
						value[3*node_Num+3*(wide+1)*(depth+1)*j+3*(wide+1)*k+3*i  ]	= -MCSMX[(wide+1)*(depth+1)*j+(wide+1)*k+i];	//x̍S
						value[3*node_Num+3*(wide+1)*(depth+1)*j+3*(wide+1)*k+3*i+2]	= -MCSMZ[(wide+1)*(depth+1)*j+(wide+1)*k+i];	//z̍S
					}
				}
			}
		}
	}
#if	RETURN
	else if((t>mbf_time+keep_time)&&(t<=mbf_time+keep_time+mbf_time2))//ʋψʗpiό`珉Ԃ܂Łj
	{				//t=0`mbf_time+keep_time+mbf_time2܂ŋ߂ψʏԁiψ+ێ+߂ψʁj
		for(j=push_node[4];j<push_node[5]+1;j++)								//̏ʁ@y
		{
			for(k=push_node[0];k<push_node[1]+1;k++)							//̏ʁ@z
			{
				for(i=push_node[2];i<push_node[3]+1;i++)						//̏ʁ@x
				{
				MCSMX[(wide+1)*(depth+1)*j+(wide+1)*k+i] = 2*omega*(nsx[(wide+1)*(depth+1)*j+(wide+1)*k+i]-(move_x/mbf_time2))
					+(omega*omega)*(npx[(wide+1)*(depth+1)*j+(wide+1)*k+i]+move_x-(move_x/mbf_time2)*(t-(mbf_time+keep_time)));				//xɕψʂ

				MCSMY[(wide+1)*(depth+1)*j+(wide+1)*k+i] = 2*omega*(nsy[(wide+1)*(depth+1)*j+(wide+1)*k+i]-(move_y/mbf_time2))
					+(omega*omega)*(npy[(wide+1)*(depth+1)*j+(wide+1)*k+i]+move_y-(move_y/mbf_time2)*(t-(mbf_time+keep_time)));				//yɕψʂ

				MCSMZ[(wide+1)*(depth+1)*j+(wide+1)*k+i] = 2*omega*(nsz[(wide+1)*(depth+1)*j+(wide+1)*k+i]-(move_z/mbf_time2))
					+(omega*omega)*(npz[(wide+1)*(depth+1)*j+(wide+1)*k+i]+move_z-(move_z/mbf_time2)*(t-(mbf_time+keep_time)));				//zɕψʂ

				value[3*node_Num+3*(wide+1)*(depth+1)*j+3*(wide+1)*k+3*i+1]	= -MCSMY[(wide+1)*(depth+1)*j+(wide+1)*k+i];	//y̍S
#if	BINDING		//S(ʊ̗L)
				value[3*node_Num+3*(wide+1)*(depth+1)*j+3*(wide+1)*k+3*i  ]	= -MCSMX[(wide+1)*(depth+1)*j+(wide+1)*k+i];	//x̍S				
				value[3*node_Num+3*(wide+1)*(depth+1)*j+3*(wide+1)*k+3*i+2]	= -MCSMZ[(wide+1)*(depth+1)*j+(wide+1)*k+i];	//z̍S
#endif	//BINDING				
				}
			}
		}
	}
#endif	//RETURN
}